command_dgenerate:
    type: command
    name: dgenerate
    description: Paste a schematic from a pool and generate a structure. Optionally, specify the size, spawn location, and world to generate the structure in.
    usage: /dgenerate (name) (pool) [size] [location]( x,y,z ) (world)
    aliases:
        - dgen
    script:
        # Check if command is valid
        - if <context.args.size> > 4:
            - narrate "<&4>Too many arguments! (No spaces allowed!)"
            - stop
        - else if <context.args.size> < 1:
            - narrate "/dgenerate (name) (pool) [size] [location]( x,y,z ) (world)"
            - narrate ----------------------------------------------
            - narrate "Paste a schematic from a pool and generate a structure."
            - narrate "Optionally, specify the size and spawn location."
            - narrate ----------------------------------------------
            - stop
        # Checks if the size is a whole, positive, number that doesn't contain anything else
        - if !<context.args.get[3].abs.round.is_truthy> && <context.args.size> > 2:
            - narrate "<&4>Invalid size given!"
            - stop
        # Run command based on the number of arguments presented
        - choose <context.args.size>:
            - default:
                - narrate "<&4>Something went wrong!"
            - case 1:
                - narrate "<&4>You must specify at least a name and a pool!"
            - case 2:
                - run dschematic_generate_structure_task def.start_name:<context.args.get[1]> def.pool_name:<context.args.get[2]> def.size:4 def.location:<player.location> player:<player>
            - case 3:
                - run dschematic_generate_structure_task def.start_name:<context.args.get[1]> def.pool_name:<context.args.get[2]> def.size:<context.args.get[3].abs.round> def.location:<player.location> player:<player>
            - case 4:
                - run dschematic_generate_structure_task def.start_name:<context.args.get[1]> def.pool_name:<context.args.get[2]> def.size:<context.args.get[3].abs.round> def.location:<location[<context.args.get[4]>,<player.location.world.name>]> player:<player>
            - case 5:
                - run dschematic_generate_structure_task def.start_name:<context.args.get[1]> def.pool_name:<context.args.get[2]> def.size:<context.args.get[3].abs.round> def.location:<location[<context.args.get[4]>,<context.args.get[5]>]> player:<player>