command_djigsaw_save:
    type: command
    name: djigsaw
    description: Flag a connector jigsaw with a return or call name.
    usage: /djigsaw (Name)
    aliases:
        - djig
    script:
        - if <context.args.size> != 1:
            - narrate "<&4>Invalid Name (No spaces!)"
            - stop
        - run djigsaw_save_task def.name:<context.raw_args> player:<player>

## RETURN AND CALL NAMES HAVE NOT BEEN IMPLEMENTED YET IN GENERATION
## HOWEVER THEY MUST BE NAMED AND FLAGGED IN ORDER FOR THE JIGSAW TO SAVE INSIDE A SCHEMATIC

djigsaw_save_task:
    type: task
    debug: false
    definitions: name
    script:
        - define player <player>
        - define location <[player].flag[dschematic.jigsaw.location]>
        - define material <[location].material>
        - if !<[location].is_truthy> || <[material].name> != jigsaw:
            - narrate "<&4>No jigsaw was selected at <[location].simple>"
            - flag <[location]> dschematic.jigsaw:!
            - stop

        - if <[material].direction.before[_]> == UP ||  <[material].direction.before[_]> == DOWN:
            - narrate "<&4>Jigsaws facing up or down are not supported at the moment"
            - narrate "<&4>Check the jigsaw at <[location].simple>"
            - flag <[location]> dschematic.jigsaw:!
            - stop
        # If all checks are passsed above, flag the jigsaw as savable in a schematic
        - flag <[location]> dschematic.jigsaw.direction:<[material].direction>
        - choose <[player].flag[dschematic.jigsaw.wants]>:
            - default:
                - narrate "<&4>Something went wrong! Try selecting the location again."
            - case return:
                - flag <[location]> dschematic.jigsaw.return:<[name]>
                - narrate "<&e>Saved the return name of <[location].simple> as <&dq><[name]><&dq>"
            - case call:
                - flag <[location]> dschematic.jigsaw.call:<[name]>
                - narrate "<&e>Saved the call name of <[location].simple> as <&dq><[name]><&dq>"